
package  com.b.team;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.graphics.BlurMaskFilter;
import android.graphics.Canvas;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.os.Bundle;
import android.util.Log;
import android.view.Display;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;

public class ImageFilter extends Activity {
	
	private static final String TAG = "Bicture_ImageFilter";
	private Context mContext = null;
	ImageView imageView;
	Bitmap BM;	
	@Override

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.filtereffect);
        mContext = this;
        
        //INTENT PARSING
        Intent I = getIntent();	
        Bundle extras = I.getExtras();
        String imgPath = extras.getString("filename");	//filename string ޾ƿ imaPath 
        
        imageView = (ImageView)findViewById(R.id.changeimage);	//ImageView ҷ
        
        BitmapFactory.Options bfo = new BitmapFactory.Options();
        bfo.inJustDecodeBounds = true;
        BM = BitmapFactory.decodeFile(imgPath, bfo);	//Creating Bitmap //OUT OF MEMORY here!!
        
        Display currentDisplay = getWindowManager().getDefaultDisplay();
        @SuppressWarnings("deprecation")
		int dw = currentDisplay.getWidth();
        @SuppressWarnings("deprecation")
		int dh = currentDisplay.getHeight();

        int heightRatio = (int)Math.ceil(bfo.outHeight/(float)dh); //floor, round...
        int widthRatio = (int)Math.ceil(bfo.outWidth/(float)dw);
        
        Log.i(TAG, "outHeight" + bfo.outHeight );
        Log.i(TAG, "outWidth" + bfo.outWidth );
        
        if(heightRatio > 1 && widthRatio > 1)
        {
        	if(heightRatio > widthRatio)
        	{
        		bfo.inSampleSize = heightRatio;
        	}
        	else
        	{
        		bfo.inSampleSize = widthRatio;
        	}
        }
        
        Log.i(TAG, "in Sample size = " + bfo.inSampleSize);
        
        //IN SAMPLE SIZE has some error. over about 5000, sample size not working properly.
        if(bfo.inSampleSize == 0 && bfo.outHeight > 1000 || bfo.outWidth > 1000) bfo.inSampleSize = 8;
        
        bfo.inJustDecodeBounds = false;
        
		try { //Creating Bitmap //OUT OF MEMORY zone T.T
			BM = BitmapFactory.decodeFile(imgPath, bfo);	
			Paint Pnt = new Paint();
			Pnt.setAntiAlias(true);
			Bitmap M_BM = Bitmap.createBitmap(BM.getWidth(), BM.getHeight(), Config.ARGB_8888);
			Matrix MT = new Matrix();
			Canvas canvas = new Canvas(M_BM);
			BlurMaskFilter blur = new BlurMaskFilter(20, BlurMaskFilter.Blur.INNER);
			Pnt.setMaskFilter(blur);
			canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
			imageView.setImageBitmap(M_BM); 
		} catch(Exception e) {
			Log.e(TAG, " "+e);
			finish();
		}
		
		//Pnt.setMaskFilter(emboss);
		//canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
		
//		ColorMatrix cm2 = new ColorMatrix(new float[]{
//				0.299f, 0.578f, 0.114f, 0, 0,
//				0.299f, 0.578f, 0.114f, 0, 0,
//				0.299f, 0.578f, 0.114f, 0, 0,
//				0, 0, 0, 1, 0}
//		);
//		Pnt.setColorFilter(new ColorMatrixColorFilter(cm2));
//		canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
        
//		ColorMatrix cm1 = new ColorMatrix(new float[]{
//				-1, 0, 0, 0, 255,
//				0, -1, 0, 0, 255,
//				0, 0, -1, 0, 255,
//				0, 0, 0, 1, 0}
//		);
//		Pnt.setColorFilter(new ColorMatrixColorFilter(cm1));
//		canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
//		

//		Pnt.setColorFilter(new PorterDuffColorFilter(Color.YELLOW, PorterDuff.Mode.DARKEN));
//		canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
//		
		
		imageView.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				Intent I = new Intent(mContext, ImageViewer.class);
				I.putExtra("isNext", "NEXT");
				finish();
				mContext.startActivity(I);
			}
		});
		
    }

	Button.OnClickListener mClickListener = new View.OnClickListener(){
    	public void onClick(View v){  	
    		//create mutuable Bitmap
    		Bitmap M_BM = Bitmap.createBitmap(BM.getWidth(), BM.getHeight(), Config.ARGB_8888);
    		Matrix MT = new Matrix();
    			
    		
/*    		switch (v.getId()){
    		case R.id.btn11:	//up||down
    			MT.setScale(1, -1);
    			M_BM = Bitmap.createBitmap(BM, 0, 0, BM.getWidth(), BM.getHeight(), MT, false);
    				break;
    		case R.id.btn12:	//left||right
    			MT.setScale(-1, 1);	
    			M_BM = Bitmap.createBitmap(BM, 0, 0, BM.getWidth(), BM.getHeight(), MT, false);
    		    break;
    		case R.id.btn13:	//(up||down)&&(left||right)
    			MT.setScale(-1, -1);
    			M_BM = Bitmap.createBitmap(BM, 0, 0, BM.getWidth(), BM.getHeight(), MT, false);
    			break;
    		case R.id.blurmask:	//blurmask filter
    			BlurMaskFilter blur = new BlurMaskFilter(20, BlurMaskFilter.Blur.INNER);
    			Pnt.setMaskFilter(blur);
    			canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
      			break;
    		case R.id.embossmask:	//embossmask filter
    			EmbossMaskFilter emboss = new EmbossMaskFilter(new float[] {3, 5, 1}, 0.7f, 6, 5);
        		Pnt.setMaskFilter(emboss);
        		canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
      			break;
    		case R.id.opposit:	//lightingcolor
    			ColorMatrix cm1 = new ColorMatrix(new float[]{
        				-1, 0, 0, 0, 255,
        				0, -1, 0, 0, 255,
        				0, 0, -1, 0, 255,
        				0, 0, 0, 1, 0}
        		);
    			Pnt.setColorFilter(new ColorMatrixColorFilter(cm1));
        		canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
    			break;
    		case R.id.bw:	//matrixcolor
    			ColorMatrix cm2 = new ColorMatrix(new float[]{
        				0.299f, 0.578f, 0.114f, 0, 0,
        				0.299f, 0.578f, 0.114f, 0, 0,
        				0.299f, 0.578f, 0.114f, 0, 0,
        				0, 0, 0, 1, 0}
        		);
        		Pnt.setColorFilter(new ColorMatrixColorFilter(cm2));
        		canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
    			break;
    		case R.id.color:	//PoterDuffcolor
    			Pnt.setColorFilter(new PorterDuffColorFilter(Color.YELLOW, PorterDuff.Mode.DARKEN));
        		canvas.drawBitmap(BM, 0, 0, Pnt); // Bitmap draw & save
    			break;
    		case R.id.back:	//recovery
    			canvas.drawBitmap(BM, 0, 0, null); // Bitmap draw & save
    			break;
    		}
    		*/
    		
    		
    		
    	//	IV.setImageBitmap(M_BM);
    	}
    };
}
