package com.b.team;

import java.io.File;
import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Matrix;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.provider.MediaStore;
import android.util.Log;
import android.view.Display;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SubMenu;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView.OnScrollListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AbsListView;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class ImageViewer extends Activity {

	Context mContext;
	MainPanelAdapter Adapter;
	final static int CAMERA_RESULT = 0;
	private static final String TAG = "Bicture";
	protected static final boolean DELETE = true;
	GridView gridView;
	Cursor imageCursor;
	private final static boolean LogOnOff = false;
	private static int currentPosition = 1;
	String[] proj = { MediaStore.Images.Media._ID,
			MediaStore.Images.Media.DATA, MediaStore.Images.Media.DISPLAY_NAME };
	private boolean isDeleteMode = false;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// dalvik.system.VMRuntime.getRuntime().setTargetHeapUtilization(0.7f);
		//TODO: Too slowly.
		sendBroadcast(new Intent(Intent.ACTION_MEDIA_MOUNTED, Uri.parse("file://"+ Environment.getExternalStorageDirectory())));
		setContentView(R.layout.main);
		mContext = this;

		Adapter = new MainPanelAdapter(this, this);
		gridView = (GridView) findViewById(R.id.grid);
		gridView.setAdapter(Adapter);

		Intent I = getIntent();
		Bundle extras = I.getExtras();
		String isNext = null;
		try {
			isNext = extras.getString("isNext");
		} catch (Exception e) {
			Log.i(TAG, "FirstTime launching ");
		}

		if (isNext != null && isNext.equals("NEXT")) {
			boolean flag = true;
			// TODO
			// if(currentPosition > )
			try {
				Adapter.callImageViewer(currentPosition += 1, !DELETE);
			} catch (Exception e) {
				flag = false;
			}
			if (flag)
				;

			finish();
		}

		gridView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {

				if (isDeleteMode) {
					Adapter.callImageViewer(position, DELETE);
					// onResume();
				} else {
					currentPosition = position;
					Adapter.callImageViewer(position, !DELETE);
				}
			}
		});

		gridView.setOnScrollListener(new OnScrollListener() {

			@Override
			public void onScrollStateChanged(AbsListView view, int scrollState) {
				// TODO Auto-generated method stub
			   switch (scrollState) {
		        case SCROLL_STATE_IDLE:
//		            if (view.getLastVisiblePosition() >= mTotalItemCount - 1 && mTotalItemCount > 0) {
//		                if (getListView().getFooterViewsCount() == 1 && !mIsLoading) {
//		                    mIsLoading = true;
//		                    //setProgressBarIndeterminateVisibility(true);
//		                    mListFooter.setVisibility(View.VISIBLE);
//		                    Thread thread = new Thread(mLoadListItems);
//		                    thread.start();
//		                }
//		            }
		            break;
		        case SCROLL_STATE_TOUCH_SCROLL:
		            break;
		        case SCROLL_STATE_FLING:
		            break;
		        }

			}

			@Override
			public void onScroll(AbsListView view, int firstVisibleItem,
					int visibleItemCount, int totalItemCount) {
				// TODO Auto-generated method stub

			}
		});

	}



	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		Adapter = new MainPanelAdapter(this, this);
		gridView = (GridView) findViewById(R.id.grid);
		gridView.setAdapter(Adapter);
		// imageCursor = Adapter.getImageViewer().getContentResolver().query(
		// MediaStore.Images.Media.EXTERNAL_CONTENT_URI, proj, null, null,
		// null);
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		imageCursor.close();
	}

	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		MenuItem item = menu.add(0, 1, 0, "SilentCAM").setIcon(R.drawable.icon)
				.setAlphabeticShortcut('a');
		menu.add(0, 2, 0, "Delete Mode").setIcon(R.drawable.icon);
		SubMenu etc = menu.addSubMenu("Ÿ");
		etc.add(0, 3, 0, "̷");
		etc.add(0, 4, 0, "ŸŸ");

		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item) {

		Intent intent;

		switch (item.getItemId()) {

		case 1:

			// // START CAMERA_ //NORMAL CAM
			// Intent i = new Intent(
			// android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
			// startActivityForResult(i, CAMERA_RESULT);
			// // _START CAMERA
			intent = new Intent(ImageViewer.this, SlientCamera.class);
			startActivity(intent);

			break;
		case 2:
			TextView txtView = (TextView) findViewById(R.id.deleteNoti);
			if (isDeleteMode) {
				txtView.setVisibility(View.GONE);
				isDeleteMode = false;
			} else {
				txtView.setVisibility(View.VISIBLE);
				txtView.setBackgroundColor(Color.RED);
				// txtView.setLayoutParams(new LinearLayout.LayoutParams(0,0));
				txtView.setText("Delete Mode - Click means DELETING!!!");
				txtView.setGravity(0x00000011);
				isDeleteMode = true;
			}

			break;
		case 3:
		}
		return true;
	}

	protected void onActivityResult(int requestCode, int resultCode,
			Intent intent) {
		super.onActivityResult(requestCode, resultCode, intent);

		if (intent == null) {
			Log.i(TAG, "HJH_INTENT NULL");
			return;
		}
		if (resultCode == RESULT_OK)
			;
		{
			ImageView imgV;
			Bundle extras = intent.getExtras();
			Bitmap bmp = (Bitmap) extras.get("data");
			imgV = (ImageView) findViewById(R.id.playWithCam);
			imgV.setImageBitmap(bmp);
			findViewById(R.id.grid).setVisibility(View.GONE);
			findViewById(R.id.playWithCam).setVisibility(View.VISIBLE);
		}
	}

	class MainPanelAdapter extends BaseAdapter {

		private final ImageViewer imageViewer;
		private String imgData;
		private String geoData;
		private ArrayList<String> thumbsDataList;
		private ArrayList<String> thumbsIDList;

		public MainPanelAdapter(ImageViewer imageViewer, Context c) {
			this.imageViewer = imageViewer;
			this.imageViewer.mContext = c;
			getAllImageInfo();
		}

		private void getAllImageInfo() {

			thumbsDataList = new ArrayList<String>();
			thumbsIDList = new ArrayList<String>();

			String[] proj = { MediaStore.Images.Media._ID,
					MediaStore.Images.Media.DATA,
					MediaStore.Images.Media.DISPLAY_NAME };

			imageCursor = this.imageViewer.getContentResolver().query(
					MediaStore.Images.Media.EXTERNAL_CONTENT_URI, proj, null,
					null, null);

			if (imageCursor != null && imageCursor.moveToFirst()) {
				String thumbsID;
				String thumbsData;
				String thumbsImageID;


				int thumbsIDCol = imageCursor
						.getColumnIndex(MediaStore.Images.Media._ID);
				int thumbsDataCol = imageCursor
						.getColumnIndex(MediaStore.Images.Media.DATA);
				int thumbsImageIDCol = imageCursor
						.getColumnIndex(MediaStore.Images.Media.DISPLAY_NAME);

				do {
					thumbsID = imageCursor.getString(thumbsIDCol);
					thumbsData = imageCursor.getString(thumbsDataCol);
					thumbsImageID = imageCursor.getString(thumbsImageIDCol);

					if (thumbsImageID != null) {
						thumbsIDList.add(thumbsID);
						thumbsDataList.add(thumbsData);// add to thumbsDatas
					}
				} while (imageCursor.moveToNext());
			}
			imageCursor.close();
			return;
		}

		/** Get Bitmap's Width **/
		public int getBitmapOfWidth(String fileName) {
			try {
				BitmapFactory.Options options = new BitmapFactory.Options();
				options.inJustDecodeBounds = true;
				BitmapFactory.decodeFile(fileName, options);
				return options.outWidth;
			} catch (Exception e) {
				return 0;
			}
		}

		/** Get Bitmap's height **/
		public int getBitmapOfHeight(String fileName) {

			try {
				BitmapFactory.Options options = new BitmapFactory.Options();
				options.inJustDecodeBounds = true;
				BitmapFactory.decodeFile(fileName, options);

				return options.outHeight;
			} catch (Exception e) {
				return 0;
			}
		}

		public void callImageViewer(int selectedIndex, boolean delete) {
			String imgPath = null;
			try {
				imgPath = getImageInfo(imgData, geoData,
						thumbsIDList.get(selectedIndex));
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
				Toast.makeText(ImageViewer.this, "Already gone...",
						Toast.LENGTH_SHORT);
			}

			Log.i(TAG, " " + imgPath);

			if (delete) {

				try {
					File fp = new File(imgPath);
					if (fp.exists()) {
						fp.delete();

						//TODO: checking all of this.
						getAllImageInfo();
						Toast.makeText(ImageViewer.this, "DELETED",
								Toast.LENGTH_SHORT).show();
						imageViewer.onResume();
					} else {
						Toast.makeText(ImageViewer.this, "Already gone...",
								Toast.LENGTH_SHORT);
					}

				} catch (Exception e) {
					// TODO: handle exception
					Log.e(TAG, "FILE EXCEPTION" + e);

				}
				Log.i(TAG, imgPath + " has been DELETED ");
			} else {
				Intent I = new Intent(this.imageViewer.mContext,
						ImageFilter.class);
				I.putExtra("filename", imgPath);
				this.imageViewer.startActivityForResult(I, 1);
			}
		}

		private String getImageInfo(String ImageData, String Location,
				String thumbID) {

			String imageDataPath = null; // reset imageDataPath

			Cursor imageCursor = this.imageViewer.getContentResolver().query(
					MediaStore.Images.Media.EXTERNAL_CONTENT_URI, proj,
					"_ID='" + thumbID + "'", null, null);
			if (imageCursor != null && imageCursor.moveToFirst()) {
				if (imageCursor.getCount() > 0) {
					int imgData = imageCursor
							.getColumnIndex(MediaStore.Images.Media.DATA);
					imageDataPath = imageCursor.getString(imgData);
				}
			}
			// imageCursor.close();
			return imageDataPath;
		}

		public boolean deleteSelected(int sIndex) {
			return true;
		}

		public int getCount() {
			return thumbsIDList.size();
		}

		public Object getItem(int position) {
			return position;
		}

		public long getItemId(int position) {
			return position;
		}

		public ImageViewer getImageViewer() {
			return this.imageViewer;
		}

		/**
		 * Abstract method TODO: bitmap loading method memory leakage, speed
		 * problem
		 *
		 * */
		ImageView imageView;

		public View getView(int position, View convertView, ViewGroup parent) {

			//			ImageView imageView; going out.

			if(LogOnOff) Log.i(TAG, "++++++++++++++++++++++GET_VIEW+++++++++++++++++++++");

			if (convertView == null) {
				imageView = new ImageView(this.imageViewer.mContext);
				imageView.setLayoutParams(new GridView.LayoutParams(185, 185));
				imageView.setAdjustViewBounds(true);
				imageView.setScaleType(ImageView.ScaleType.FIT_CENTER);
				imageView.setPadding(2, 2, 2, 2); // Padding setting
			} else {
				imageView = (ImageView) convertView;
			}

			BitmapFactory.Options bfo = new BitmapFactory.Options();

//			TODO:SPEED UP
				bfo.inJustDecodeBounds = true;
				Bitmap BM = BitmapFactory.decodeFile(thumbsDataList.get(position),
						bfo);
		        Display currentDisplay = getWindowManager().getDefaultDisplay();
		        @SuppressWarnings("deprecation")
				int dw = currentDisplay.getWidth();
		        @SuppressWarnings("deprecation")
				int dh = currentDisplay.getHeight();

		        int heightRatio = (int)Math.ceil(bfo.outHeight/(float)dh); //floor, round...
		        int widthRatio = (int)Math.ceil(bfo.outWidth/(float)dw);

		        if(LogOnOff) Log.i(TAG, "outHeight" + bfo.outHeight );
		        if(LogOnOff) Log.i(TAG, "outWidth" + bfo.outWidth );

		        if(heightRatio > 1 && widthRatio > 1)
		        {
		        	if(heightRatio > widthRatio)
		        	{
		        		bfo.inSampleSize = heightRatio+4;
		        	}
		        	else
		        	{
		        		bfo.inSampleSize = widthRatio+4;
		        	}
		        }

		        if(LogOnOff) Log.i(TAG, "in Sample size = " + bfo.inSampleSize);

		        //IN SAMPLE SIZE has some error. over about 5000, sample size not working properly.
		        if(bfo.outHeight < 200 && bfo.outWidth < 200) bfo.inSampleSize = 0;

		        bfo.inJustDecodeBounds = false;

//			bfo.inSampleSize = 4; // very very important.
			///////////////////////////////////////////////////////////////////

		        //TODO : make this thread for increasing UX


//		        Thread t1= new Thread(new Runnable() {
//					public void run() {
//
//				handler.sendEmptyMessage(0);
//					}
//
//
			if(LogOnOff) Log.i("DEbF", "in " + String.valueOf(System.currentTimeMillis()));

			BM = BitmapFactory.decodeFile(thumbsDataList.get(position),
					bfo);

			Matrix mat = new Matrix();
			mat.postScale(1, 1);

			try {
				BM = Bitmap.createBitmap(BM, 0, 0, BM.getWidth(),
						BM.getHeight(), mat, true); // useless
				imageView.setImageBitmap(BM);

			} catch (Exception e) {
				// TODO: handle exception THIS is POINT occured Exception of
				// NULL~
				if(LogOnOff) Log.e(TAG, "BM EXCEPTION " + e);
			}
			return (View)imageView;
		}

//		private Handler handler= new Handler() {
//			public void handleMessage(Message msg) {
//			}
//		};

	}
}
