package com.b.team;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Iterator;
import java.util.List;

import android.app.Activity;
import android.content.ContentValues;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.hardware.Camera;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore.Images.Media;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Toast;

public class SlientCamera extends Activity implements SurfaceHolder.Callback, Camera.PictureCallback,
	OnClickListener {

	private static final String TAG = "SlientCamera_";
	SurfaceView cameraView;
	SurfaceHolder surfaceHolder;
	Camera camera;
	
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
		setContentView(R.layout.camera);
		cameraView = (SurfaceView)this.findViewById(R.id.silentcam);
		surfaceHolder = cameraView.getHolder();
		surfaceHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
		surfaceHolder.addCallback(this);
		
		cameraView.setFocusable(true);
		cameraView.setFocusableInTouchMode(true);
		cameraView.setClickable(true);
		
		cameraView.setOnClickListener(this);
		
	}
	
	@Override
	public void surfaceChanged(SurfaceHolder arg0, int arg1, int arg2, int arg3) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void surfaceCreated(SurfaceHolder arg0) {
		// TODO Auto-generated method stub
		camera = Camera.open();
		
		
		try {
			
			Camera.Parameters parameters = camera.getParameters();
			
//			IMAGE_FILTERING.
//			//Checking available effect first.
//			List<String> colorEffects = parameters.getSupportedColorEffects();
//			Iterator<String> cfIterator = colorEffects.iterator();
//			while(cfIterator.hasNext()) {
//				String currentEffect = cfIterator.next();
//					if(currentEffect.equals(Camera.Parameters.EFFECT_SOLARIZE)) {
//						parameters.setColorEffect(Camera.Parameters.EFFECT_SOLARIZE);
//					break;
//				}
//			}
			
			
			if(this.getResources().getConfiguration().orientation != Configuration.ORIENTATION_LANDSCAPE) {
				parameters.set("orientation", "protrait");
				parameters.setRotation(90);
			} else {
				parameters.set("orientation", "landscape");
				parameters.setRotation(0);
			}
			
			camera.setParameters(parameters);
			
			camera.setPreviewDisplay(arg0);
			
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			camera.release();
		}
		camera.startPreview();
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO Auto-generated method stub
		camera.stopPreview();
		camera.release();
	}

	@Override
	public void onPictureTaken(byte[] data, Camera camera) {
		// TODO Auto-generated method stub
		Uri imageFileUrl = getContentResolver().insert(Media.EXTERNAL_CONTENT_URI, new ContentValues());
		
		try {
			OutputStream imageFile = getContentResolver().openOutputStream(imageFileUrl);
			imageFile.write(data);
			imageFile.flush();
			imageFile.close();
		} catch(FileNotFoundException e) {
			Log.e(TAG, " "+e);
		} catch(IOException e) {
			Log.e(TAG, " "+e);
		}
		
		camera.startPreview();
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		camera.takePicture(null, null, this);
		Toast.makeText(this, "SAVED...plz wait til disappear this", Toast.LENGTH_SHORT).show();
	}

}
